﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private WebView1 As WebView
	Private Button1 As B4XView
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
End Sub

' Handle alerts from JavaScript
Sub Alert_Event (MethodName As String, args() As Object) As Object
	Dim jo As JavaObject = args(0)
	Log("MethodName: " & MethodName)
	Log("args(0): " & args(0))
'''	Log("args(1): " & args(1))
	Dim eventname As String
	Dim value As Object
	eventname = jo.RunMethod("getData", Null)
	Dim eventsub As String = Regex.Split(":", eventname)(0)
	value = Regex.Split(":", eventname)(1)
	Log("message: " & jo.RunMethod("getData", Null))
	CallSubDelayed2(Me, eventsub, value)
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub Button1_Click
	Dim videoid As String = "QJe1tGI1EZc" '''"gOO5XtCvSe8"
	'''"http://www.youtube.com/watch?v=QJe1tGI1EZc"
	
	Dim jo As JavaObject = WebView1
	Dim webEngine As JavaObject = jo.RunMethod("getEngine", Null)

	' Set an alert handler to process JavaScript calls
	webEngine.RunMethod("setOnAlert", Array(jo.CreateEvent("javafx.event.EventHandler", "Alert", False)))
    
	
	Dim html As String = $"<!DOCTYPE html>
<html style="height: 100%; margin: 0;">
<body>
  <div id="player" style="height: 100%; width: 100%;"></div>

  <script>
    // Load YouTube IFrame API
    var tag = document.createElement('script');
    tag.src = "https://www.youtube.com/iframe_api";
    var firstScriptTag = document.getElementsByTagName('script')[0];
    firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);

    var player;

    // Called when YouTube IFrame API is ready
    function onYouTubeIframeAPIReady() {
      player = new YT.Player('player', {
        height: '100%',
        width: '100%',
        videoId: '${videoid}', // Video ID dynamically set
        playerVars: {
	'autoplay': 0, // No autoplay to avoid restrictions
	'mute': 0, // Video starts unmuted
	'controls': 1,
	'playsinline': 1
        },
        events: {
	'onReady': onPlayerReady,
	'onError': onPlayerError
        }
      });
    }

    // Called when the player is ready
    function onPlayerReady(event) {
      // Notify B4J that the player is ready
      callB4jSub('Player_Ready', 'true');
    }

    // Called when there is an error in the player
    function onPlayerError(event) {
      console.error("YouTube Player Error:", event.data);
      callB4jSub('Player_Error', event.data.toString());
    }

    // Function to play video
    function playVideo() {
      player.playVideo();
    }

    // Function to stop video
    function stopVideo() {
      player.stopVideo();
    }

    // Function to unmute video
    function unMuteVideo() {
      player.unMute();
    }

    // Function to notify B4J about dimensions
    function getPlayerDimensions() {
      var playerElement = document.getElementById('player');
      var height = playerElement.offsetHeight;
      var width = playerElement.offsetWidth;
      callB4jSub('Player_Dimensions', JSON.stringify({ Dimensions: [height, width] }));
    }

    // Function to call B4J method
    function callB4jSub(methodName, value) {
      try {
        // Use alert for communication with B4J WebView
        alert(methodName + ':' + value);
      } catch (err) {
        console.error("Error in callB4jSub:", err.message);
      }
    }
  </script>
</body>
</html>"$

WebView1.LoadHtml(html)
End Sub

Private Sub Player_Ready(value As Object)
	Log("called from js: " & value)
	Dim Play As String = $"playVideo()"$
	
	Dim engine As JavaObject
	engine = WebView1.As(JavaObject).RunMethod("getEngine", Null)
	'''WebView1.As(JavaObject).RunMethodJO("getEngine", Null).RunMethod("executeScript", Array(Play))
	engine.RunMethod("setJavaScriptEnabled", Array(True))
	Log("javacript is enabled: " & engine.RunMethodjo("javaScriptEnabledProperty", Null).RunMethod("getValue", Null))
	engine.RunMethod("executeScript", Array(Play))
	
End Sub

Private Sub Player_Error(error As String)
	Log("error: " & error)
End Sub

Private Sub WebView1_PageFinished (Url As String)
	Log("page finished: " & Url)
End Sub

Sub B4XPage_Resize (Width As Int, Height As Int)
	Log("resizing page")
	WebView1.PrefWidth = Width * 0.9
	WebView1.PrefHeight = Height - Button1.Top
End Sub